package org.processmining.humbertogarciacaballero.models.gui.components;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;

import javax.swing.Box;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.SwingConstants;

public class ColorLeyendComponent extends JPanel {

	private JRadioButton b;
	
	public ColorLeyendComponent(String radioLabel, String firstLabel, String lastLabel, Color[] palette) {
		setBackground(new Color(0, 0, 0, 0));
		setLayout(new BorderLayout());
		
		b = new JRadioButton(radioLabel);
		b.setHorizontalAlignment(SwingConstants.CENTER);
//		b.setBackground(new Color(0,0,0,0));
		add(b, BorderLayout.NORTH);
		
		JPanel panel = new JPanel();
		panel.setBackground(new Color(0,0,0,0));
		panel.setLayout(new FlowLayout(FlowLayout.LEFT, 0, 0));
		JLabel label = new JLabel(firstLabel);
		panel.add(label);
		Component horizontalStrut = Box.createHorizontalStrut(10);
		panel.add(horizontalStrut);
		
		for (Color color : palette) {
			JPanel panel2 = new JPanel();
			panel2.setBackground(color);
			panel2.setPreferredSize(new Dimension(20, 20));
			panel.add(panel2);
		}
		
		Component horizontalStrut_1 = Box.createHorizontalStrut(10);
		panel.add(horizontalStrut_1);
		JLabel label2 = new JLabel(lastLabel);
		panel.add(label2);
		Component horizontalStrut_2 = Box.createHorizontalStrut(10);
		panel.add(horizontalStrut_2);
		
		add(panel, BorderLayout.SOUTH);
	}
	
	public boolean isSelected() {
		return b.isSelected();
	}
	
	public JRadioButton getRadioButton() {
		return b;
	}
}
