package org.processmining.humbertogarciacaballero.models.gui.controllers;

import java.awt.Point;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;

import org.processmining.humbertogarciacaballero.models.gui.components.HotBoxMenu;

import prefuse.Display;
import prefuse.controls.ControlAdapter;

public class MenuController extends ControlAdapter {
	
	private HotBoxMenu hotBoxMenuComponent;
	private Point p;
	
	public MenuController(Display d) {
		hotBoxMenuComponent = new HotBoxMenu();
		d.add(hotBoxMenuComponent, 0);
		p = new Point();
	}
	
	public void mouseMoved(MouseEvent e) {
		p.setLocation(e.getPoint());
	}
	
    /**
     * @see prefuse.controls.Control#keyPressed(java.awt.event.KeyEvent)
     */
    public void keyPressed(KeyEvent e) {
    	if (e.getKeyCode() == KeyEvent.VK_CONTROL && !hotBoxMenuComponent.isVisible()) {
    		int x = (int) p.getX(), y = (int) p.getY();
            x = x - (hotBoxMenuComponent.getWidth() / 2);
            y = y - (hotBoxMenuComponent.getHeight() / 2);
            hotBoxMenuComponent.setLocation(x, y);
            hotBoxMenuComponent.setVisible(true);
            ((Display) e.getSource()).repaint();
    	}
    } 

    /**
     * @see prefuse.controls.Control#keyReleased(java.awt.event.KeyEvent)
     */
    public void keyReleased(KeyEvent e) {
    	if (e.getKeyCode() == KeyEvent.VK_CONTROL) {
    		hotBoxMenuComponent.setVisible(false);
    		((Display) e.getSource()).repaint();
    	}
    } 
}
