package org.processmining.humbertogarciacaballero.models.gui.controllers;

import java.awt.event.MouseEvent;
import java.awt.geom.Rectangle2D;

import org.processmining.humbertogarciacaballero.models.model.PNConstants;

import prefuse.Display;
import prefuse.controls.ControlAdapter;
import prefuse.visual.EdgeItem;
import prefuse.visual.VisualItem;

public class SimplifiedEdgeInformationControl extends ControlAdapter {

	private Display d;
	private EdgeItem current;
	private Rectangle2D r;
	
	public SimplifiedEdgeInformationControl(Display d) {
		this.d = d;
		r = new Rectangle2D.Double();
	}
	
	@Override
	public void itemEntered(VisualItem item, MouseEvent e) {
		if (item instanceof EdgeItem && item.getBoolean(PNConstants.SIMPLIFIED_KEY)) {
			if (current != null) {
				updateItem(current, true);
			}
			current = (EdgeItem) item;
			updateItem(item, false);
			checkVisibility(current);
		}
	}
	
	@Override
	public void itemExited(VisualItem item, MouseEvent e) {
		if (current == item) {
			updateItem(item, true);
			current = null;
		}
	}
	
	private void updateItem(VisualItem item, boolean simplified) {
		item.setBoolean(PNConstants.SIMPLIFIED_KEY, simplified);
		item.getVisualization().run(PNConstants.VIS_DECORATORS_ACTIONS_NAME);
		item.getVisualization().run(PNConstants.VIS_REPAINT_ACTIONS_NAME);
	}
	
	private void checkVisibility(EdgeItem item) {
//		NodeItem source = item.getSourceItem();
//		Rectangle2D sourceBounds = source.getBounds();
//		NodeItem target = item.getTargetItem();
//		Rectangle2D targetBounds = target.getBounds();
//		
//		r.setFrame(d.getDisplayX(), d.getDisplayY(), d.getWidth(), d.getHeight());
//		
//		System.out.println("Source: " + r.intersects(sourceBounds));
//		System.out.println("Target: " + r.intersects(targetBounds));
//		
	}
}
