package org.processmining.humbertogarciacaballero.models.model.layout.stage.emplacer;

public enum EmplacingStrategy {

	FAST_AND_SIMPLE_STRATEGY("Fast and simple strategy", FastAndSimpleEmplacer.class), HEURISTIC_STRATEGY(
			"Heuristic strategy", HeuristicEmplacer.class), SIMPLEX_STRATEGY("Simplex strategy", SimplexEmplacer.class);

	private final String label;

	private final Class<? extends Emplacer> algorithm;

	private EmplacingStrategy(String label, Class<? extends Emplacer> algorithm) {
		this.label = label;
		this.algorithm = algorithm;
	}

	public Class<? extends Emplacer> getAlgorithm() {
		return algorithm;
	}

	public String toString() {
		return label;
	}
}
