package org.processmining.humbertogarciacaballero.models.model.layout.stage.layerer;

import java.util.Iterator;

import org.processmining.humbertogarciacaballero.models.model.layout.stage.HierarchicalLayoutContext;

import prefuse.data.Graph;
import prefuse.data.Node;

public abstract class DFSLayerer extends Layerer {

	private boolean undirected;
	
	public DFSLayerer(HierarchicalLayoutContext context, boolean undirected) {
		super(context);
		this.undirected = undirected;
	}
	
	@Override
	public void calculateLayers(Graph graph) {
		Iterator<Node> rootNodes = getRootNodes(graph);
		
		if (rootNodes.hasNext()) {
			while (rootNodes.hasNext()) {
				Node node = rootNodes.next();
				dfs(graph, node, 0);
			}
		}
	}

	private void dfs(Graph graph, Node v, int layer) {
		setLayer(v, layer);
		Iterator<Node> iter = getSuccessors(v, undirected);
		
		while (iter.hasNext()) {
			Node w = iter.next();
			if (getLayer(w) == -1) {
				dfs(graph, w, layer + 1);
			} else {
				createDummies(graph, v, w);
			}
		}
	}
}
