package org.processmining.humbertogarciacaballero.plugins;

import javax.swing.JComponent;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.humbertogarciacaballero.help.Help;
import org.processmining.prabhakardixit.processanalytics.ProcessAnalyticsVizViews;

@Plugin(name = "Interactive Petri Net Visualizer Conformance", returnLabels = { "Visualized laidout Petri net" }, returnTypes = {
		JComponent.class }, parameterLabels = { "Petri net",
				"Initial Marking" }, userAccessible = true, help = Help.PLUGIN_HELP_TEXT)
@Visualizer
public class ProcessAnalyticsVisualization extends InteractiveVisualizer {

	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualize(PluginContext context, ProcessAnalyticsVizViews pa) {
		pa.setContext(context); 		//update context
		return visualizeWithConformance(context, pa.getPetrinet(), pa.getLog(), pa.getReplayResult(),pa);
	}

}
