package org.processmining.prabhakardixit.processanalytics;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GradientPaint;
import java.awt.GridBagLayout;
import java.awt.Paint;
import java.util.Map;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartMouseEvent;
import org.jfree.chart.ChartMouseListener;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.axis.SubCategoryAxis;
import org.jfree.chart.entity.ChartEntity;
import org.jfree.chart.entity.XYItemEntity;
import org.jfree.chart.event.AxisChangeEvent;
import org.jfree.chart.event.AxisChangeListener;
import org.jfree.chart.labels.StandardXYItemLabelGenerator;
import org.jfree.chart.plot.CategoryPlot;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.category.GroupedStackedBarRenderer;
import org.jfree.chart.renderer.category.StandardBarPainter;
import org.jfree.chart.renderer.xy.StandardXYBarPainter;
import org.jfree.chart.renderer.xy.XYBarRenderer;
import org.jfree.data.category.CategoryDataset;
import org.jfree.data.category.DefaultCategoryDataset;
import org.jfree.data.time.TimeTableXYDataset;
import org.jfree.data.xy.DefaultTableXYDataset;
import org.jfree.data.xy.XYBarDataset;
import org.jfree.data.xy.XYSeries;
import org.jfree.ui.GradientPaintTransformType;
import org.jfree.ui.StandardGradientPaintTransformer;
import org.processmining.prabhakardixit.processanalytics.models.TimeView;

public class SwingGraph2 {

	private static DefaultCategoryDataset dataset = new DefaultCategoryDataset();
	private static DefaultTableXYDataset dataset2 = new DefaultTableXYDataset();
	private static JFrame frame = new JFrame();
	private static JPanel panel = new JPanel(new BorderLayout());
	private static TimeTableXYDataset time_dataset = new TimeTableXYDataset();
	private static RangeSlider rangeSlider = new RangeSlider();

	public static void createHistogram(JPanel frame, Map<String, Map<Double, Double>> displayView, TimeView timeView) {

		JScrollPane scrp = new JScrollPane(histogram(displayView, timeView));
		frame.removeAll();
		frame.setSize(1000, 500);
		frame.add(scrp);
		frame.revalidate();
		frame.repaint();
	}

	public static void createStackedXY(JPanel frame, Map<String, Map<Double, Double>> displayView, TimeView timeView) {

		JScrollPane scrp = new JScrollPane(stackedXYChart(displayView, timeView));
		frame.removeAll();
		frame.setSize(1000, 500);
		frame.add(scrp);
		frame.revalidate();
		frame.repaint();
	}

	private static Component histogram(Map<String, Map<Double, Double>> displayView, TimeView timeView) {
		dataset2.removeAllSeries();
		boolean legend=true;
		if(displayView.size()>8)
			legend=false;
//		final JFreeChart chart = ChartFactory.createXYBarChart("Stacked Area Chart", // chart title
//				"Time :" + timeView, // domain axis label
//				"Value", // range axis label
//				new XYBarDataset(createDataset2(displayView),0.8), // data
//				PlotOrientation.VERTICAL, // orientation
//				true, // include legend
//				true, false);
		final  JFreeChart chart = ChartFactory.createXYBarChart(
			         "Bars from arrays","x",false,"y",
			         new XYBarDataset(createDataset2(displayView),0.8),PlotOrientation.VERTICAL,legend, true, false);
		final ChartPanel chartPanel = new ChartPanel(chart);
		XYPlot plot = chart.getXYPlot();
		plot.setBackgroundPaint(Color.WHITE);
		plot.setDomainGridlinePaint(Color.WHITE);
		plot.setRangeGridlinePaint(Color.WHITE);
		plot.setOutlineVisible(false);

		//  JFreeChart chart = // your bar chart
		//CategoryPlot plot = (CategoryPlot) chart.getPlot();
		XYBarRenderer renderer = (XYBarRenderer) plot.getRenderer();
		renderer.setSeriesPaint(0, new Color(43, 140, 190, 255));
		renderer.setSeriesPaint(1, new Color(230, 85, 13, 200));
		renderer.setBarPainter(new StandardXYBarPainter());
		

		renderer.setBaseItemLabelGenerator(new StandardXYItemLabelGenerator());
		renderer.setBaseItemLabelsVisible(false);
		chart.getXYPlot().setRenderer(renderer);

		chartPanel.addChartMouseListener(new ChartMouseListener() {

			@Override
			public void chartMouseClicked(ChartMouseEvent cme) {
				ChartEntity entity = cme.getEntity();
				System.out.println("Click on bar " + entity);

			}

			@Override
			public void chartMouseMoved(ChartMouseEvent cme) {

			}
		});

		chartPanel.setMinimumSize(new Dimension(15000, 500));
		panel.removeAll();
		panel.add(chartPanel, BorderLayout.CENTER);
		panel.setPreferredSize(new Dimension(1500, 475));
		panel.revalidate();
		panel.repaint();

		//sortDataset(displayView);
		return panel;

	}

	private static CategoryDataset createDataset1(Map<String, Map<Double, Double>> displayView) {

		for (String activity : displayView.keySet()) {
			for (Double category : displayView.get(activity).keySet()) {
				System.out.println("Activity " + activity);
				System.out.println("Value: " + displayView.get(activity).get(category));
				System.out.println("Category  " + category);
				dataset.addValue(displayView.get(activity).get(category), activity, category);
			}
		}

		return dataset;
	}

	public static Component stackedXYChart(Map<String, Map<Double, Double>> displayView, TimeView timeView) {
		dataset2.removeAllSeries();
		boolean legend = true;
		if (displayView.size() > 8)
			legend = false;
		final JFreeChart chart = ChartFactory.createStackedXYAreaChart("Stacked Area Chart", // chart title
				"Time :" + timeView, // domain axis label
				"Value", // range axis label
				createDataset2(displayView), // data
				PlotOrientation.VERTICAL, // orientation
				legend, // include legend
				true, false);
		chart.setBackgroundPaint(Color.white);

		final XYPlot plot = (XYPlot) chart.getPlot();

		plot.setForegroundAlpha(0.5f);
		plot.setBackgroundPaint(Color.white);
		plot.setDomainGridlinePaint(Color.white);
		plot.setRangeGridlinePaint(Color.white);
		//plot.setSeriesRenderingOrder(SeriesRenderingOrder.FORWARD);

		final NumberAxis domainAxis = (NumberAxis) plot.getDomainAxis();
		domainAxis.setTickMarksVisible(true);
		domainAxis.setTickLabelsVisible(true);

		//domainAxis.setLowerMargin(0.0);
		//domainAxis.setUpperMargin(0.0);

		domainAxis.addChangeListener(new AxisChangeListener() {

			@Override
			public void axisChanged(AxisChangeEvent ace) {
				System.out.println("changing");
			}
		});

		// change the auto tick unit selection to integer units only...
		final NumberAxis rangeAxis = (NumberAxis) plot.getRangeAxis();
		rangeAxis.setStandardTickUnits(NumberAxis.createIntegerTickUnits());

		final ChartPanel chartPanel = new ChartPanel(chart);

		Dimension panelSize = frame.getSize();

		chartPanel.setSize(panelSize);
		chartPanel.addChartMouseListener(new ChartMouseListener() {

			@Override
			public void chartMouseClicked(ChartMouseEvent cme) {
				XYItemEntity entity = (XYItemEntity) cme.getEntity();
				System.out.println("Clicked on " + entity.getItem());

			}

			@Override
			public void chartMouseMoved(ChartMouseEvent cme) {

			}
		});
		chartPanel.setMinimumSize(new Dimension(15000, 500));

		panel.removeAll();
		panel.add(chartPanel, BorderLayout.CENTER);
		panel.setPreferredSize(new Dimension(1500, 475));
		panel.revalidate();
		panel.repaint();

		return panel;
	}

	private static DefaultTableXYDataset createDataset2(Map<String, Map<Double, Double>> displayView) {
		for (String activity : displayView.keySet()) {

			XYSeries tmp = new XYSeries(activity, true, false);

			for (Double category : displayView.get(activity).keySet()) {

				tmp.add(category, displayView.get(activity).get(category));

			}

			dataset2.addSeries(tmp);
		}

		return dataset2;

	}

	/**
	 * Create a panel where to show the stackedBarcharts
	 * 
	 * @param attrMapPerOutput
	 * @param numOutputs
	 * @param outputNameMap
	 * @return the Panel
	 */
	public static JPanel multiOutputPanel(JPanel frame, Map<String, Map<String, Map<String, Double>>> attrMapPerOutput,
			int numOutputs, Map<String, String> outputNameMap) {
		frame.removeAll();
		frame.setSize(2000, 500);

		JPanel gridPanel = new JPanel();

		//Define size of our Grid

		System.out.println("Size attributeMap " + attrMapPerOutput.size());

		//Change GridLayout settings
		gridPanel.setLayout(new GridBagLayout());

		//Create a chart for each attribute
		for (String attr : attrMapPerOutput.keySet()) {
			System.out.println("Create Chart for " + attr);
			final JFreeChart chart = stackedBarChart(attr, attrMapPerOutput.get(attr), outputNameMap);

			/*
			 * final JFreeChart chart =
			 * ChartFactory.createMultiplePieChart(attr, // chart title
			 * createMultiOutputDataset(attrMapPerOutput.get(attr), numOutputs,
			 * outputNameMap), // dataset TableOrder.BY_ROW, true, // include
			 * legend true, false);
			 */
			CategoryPlot plot = (CategoryPlot) chart.getCategoryPlot();
			plot.setBackgroundPaint(Color.WHITE);
			ChartPanel chartpanel = new ChartPanel(chart);
			chartpanel.setPreferredSize(new Dimension(400,400));
			gridPanel.add(chartpanel);

		}

		// panel.add(gridPanel,BorderLayout.NORTH);
		frame.add(gridPanel);
		frame.revalidate();
		frame.repaint();
		return gridPanel;
	}

	private static JFreeChart stackedBarChart(String attVal, Map<String, Map<String, Double>> outputMap,
			Map<String, String> outputnameMap) {
		final JFreeChart stackBarchart = ChartFactory.createStackedBarChart(attVal, // chart title
				"Category", // domain axis label
				"Value", // range axis label
				createDataset4BarChart(outputMap, outputnameMap), // data
				PlotOrientation.VERTICAL, // the plot orientation
				true, // legend
				true, // tooltips
				false // urls
				);

		GroupedStackedBarRenderer renderer = new GroupedStackedBarRenderer();

		/*
		 * KeyToGroupMap map = new KeyToGroupMap("A"); for(String group :
		 * outputMap.keySet()) { for (String act: outputMap.get(group).keySet())
		 * { map.mapKeyToGroup(group, act); }
		 * 
		 * }
		 * 
		 * 
		 * 
		 * renderer.setSeriesToGroupMap(map);
		 */
		renderer.setBarPainter(new StandardBarPainter());
		//renderer.setItemMargin(0.5);

		Paint p1 = new GradientPaint(0.0f, 0.0f, new Color(0x22, 0x22, 0xFF), 0.0f, 0.0f, new Color(0x88, 0x88, 0xFF));
		//renderer.setSeriesPaint(0, p1);
		//renderer.setSeriesPaint(4, p1);
		//renderer.setSeriesPaint(8, p1);

		Paint p2 = new GradientPaint(0.0f, 0.0f, new Color(0x22, 0xFF, 0x22), 0.0f, 0.0f, new Color(0x88, 0xFF, 0x88));
		// renderer.setSeriesPaint(1, p2); 
		//renderer.setSeriesPaint(5, p2); 
		//renderer.setSeriesPaint(9, p2); 

		Paint p3 = new GradientPaint(0.0f, 0.0f, new Color(0xFF, 0x22, 0x22), 0.0f, 0.0f, new Color(0xFF, 0x88, 0x88));
		//renderer.setSeriesPaint(2, p3);
		//renderer.setSeriesPaint(6, p3);
		//renderer.setSeriesPaint(10, p3);

		Paint p4 = new GradientPaint(0.0f, 0.0f, new Color(0xFF, 0xFF, 0x22), 0.0f, 0.0f, new Color(0xFF, 0xFF, 0x88));
		renderer.setSeriesPaint(3, p4);
		renderer.setSeriesPaint(7, p4);
		renderer.setSeriesPaint(11, p4);
		renderer.setGradientPaintTransformer(new StandardGradientPaintTransformer(GradientPaintTransformType.HORIZONTAL));

		renderer.setItemMargin(0.5);

		SubCategoryAxis domainAxis = new SubCategoryAxis("Case Fitness");
		domainAxis.setCategoryMargin(0.2);
		domainAxis.setLowerMargin(.1);
		//     domainAxis.setCategoryMargin(.01);
		domainAxis.setUpperMargin(.1);
		/*
		 * for(String sub: outputMap.keySet()) { domainAxis.addSubCategory(sub);
		 * }
		 */

		CategoryPlot plot = (CategoryPlot) stackBarchart.getPlot();
		plot.setDomainAxis(domainAxis);
		//plot.setDomainAxisLocation(AxisLocation.TOP_OR_RIGHT);
		plot.setRenderer(renderer);

		//plot.setFixedLegendItems(createLegendItems(outputMap));
		
		final ChartPanel chartPanel = new ChartPanel(stackBarchart);
chartPanel.setMaximumSize(new Dimension(300,300));
chartPanel.setMinimumSize(new Dimension(300,300));
chartPanel.setPreferredSize(new Dimension(300,300));
		Dimension panelSize = panel.getSize();

		panel.add(chartPanel, BorderLayout.CENTER);

//		chartPanel.setSize(panelSize);
		chartPanel.addChartMouseListener(new ChartMouseListener() {

			@Override
			public void chartMouseClicked(ChartMouseEvent cme) {
				XYItemEntity entity = (XYItemEntity) cme.getEntity();
				System.out.println("Clicked on " + entity.getItem());

			}

			@Override
			public void chartMouseMoved(ChartMouseEvent cme) {

			}
		});

		return stackBarchart;

	}

	/**
	 * Create the Category Dataset for the Stacked BarChart
	 * 
	 * @param map
	 * @param outputnameMap
	 * @return Category Dataset for an attribute
	 */
	private static CategoryDataset createDataset4BarChart(Map<String, Map<String, Double>> map,
			Map<String, String> outputnameMap) {
		DefaultCategoryDataset result = new DefaultCategoryDataset();

		for (String str : map.keySet()) {
			for (String val : map.get(str).keySet()) {
				System.out.println(str + " : " + map.get(str).get(val) + " : " + val);
				result.addValue(map.get(str).get(val), val, outputnameMap.get(str));

			}

		}

		return result;
	}

}